10 # pkgs parsing utilities
11 PATH=$(dirname $0):$PATH export PATH
15 DEFAULT_PLDISTRO=planetlab
16 DEFAULT_PERSONALITY=linux64
19 COMMAND_VBUILD="vbuild-init-lxc.sh"
20 COMMAND_MYPLC="vtest-init-lxc.sh"
22 libvirt_version="1.0.4"
23 function bridge_init () {
31 # Default Value for INTERFACE_LAN
32 INTERFACE_LAN=$(netstat -rn | grep '^0.0.0.0' | awk '{print $8;}')
35 echo "========== $COMMAND: entering start - beg"
40 echo "========== $COMMAND: entering start - end"
42 # disable netfilter calls for bridge interface (they cause panick on 2.6.35 anyway)
44 # another option would be to accept the all forward packages for
45 # bridged interface like: -A FORWARD -m physdev --physdev-is-bridged -j ACCEPT
46 sysctl net.bridge.bridge-nf-call-iptables=0
47 sysctl net.bridge.bridge-nf-call-ip6tables=0
48 sysctl net.bridge.bridge-nf-call-arptables=0
50 # take extra arg for ifname, if provided
51 [ -n "$1" ] && { INTERFACE_LAN=$1; shift ; }
53 #if we have already configured the same host_box no need to do it again
54 /sbin/ifconfig $INTERFACE_BRIDGE &> /dev/null && {
55 echo "Bridge interface $INTERFACE_BRIDGE already set up - $COMMAND start exiting"
58 /sbin/ifconfig $INTERFACE_LAN &>/dev/null || {
59 echo "Cannot use interface $INTERFACE_LAN - exiting"
64 #Getting host IP/masklen
65 address=$(/sbin/ip addr show $INTERFACE_LAN | grep -v inet6 | grep inet | head --lines=1 | awk '{print $2;}')
66 [ -z "$address" ] && { echo "ERROR: Could not determine IP address for $INTERFACE_LAN" ; exit 1 ; }
68 broadcast=$(/sbin/ip addr show $INTERFACE_LAN | grep -v inet6 | grep inet | head --lines=1 | awk '{print $4;}')
69 [ -z "$broadcast" ] && echo "WARNING: Could not determine broadcast address for $INTERFACE_LAN"
71 gateway=$(netstat -rn | grep '^0.0.0.0' | awk '{print $2;}')
72 [ -z "$gateway" ] && echo "WARNING: Could not determine gateway IP"
75 echo "Creating bridge INTERFACE_BRIDGE=$INTERFACE_BRIDGE"
76 brctl addbr $INTERFACE_BRIDGE
77 #brctl stp $INTERFACE_BRIDGE yes
78 brctl addif $INTERFACE_BRIDGE $INTERFACE_LAN
79 echo "Activating promiscuous mode INTERFACE_LAN=$INTERFACE_LAN"
80 /sbin/ifconfig $INTERFACE_LAN 0.0.0.0 promisc up
82 echo "Setting bridge address=$address broadcast=$broadcast"
84 #/sbin/ifconfig $INTERFACE_BRIDGE $address broadcast $broadcast up
85 dhclient $INTERFACE_BRIDGE
88 #Reconfigure the routing table
89 echo "Configuring gateway=$gateway"
90 route add default gw $gateway
92 echo "========== $COMMAND: exiting start - beg"
95 echo "========== $COMMAND: exiting start - end"
103 function failure () {
104 echo "$COMMAND : Bailing out"
108 function cidr_notation () {
112 for i in $(seq 1 4) ; do
113 part=$(echo $netmask | cut -d. -f $i)
115 "255") cidr=$((cidr + 8));;
116 "254") cidr=$((cidr + 7));;
117 "252") cidr=$((cidr + 6));;
118 "248") cidr=$((cidr + 5));;
119 "240") cidr=$((cidr + 4));;
120 "224") cidr=$((cidr + 3));;
121 "192") cidr=$((cidr + 2));;
122 "128") cidr=$((cidr + 1));;
123 "0") cidr=$((cidr + 0));;
130 function check_yum_installed () {
132 rpm -q $package >& /dev/null || yum -y install $package
135 function check_yumgroup_installed () {
137 yum grouplist "$group" | grep -q Installed || { yum -y groupinstall "$group" ; }
140 function prepare_host() {
142 host_fcdistro="$(cat /etc/fedora-release | cut -d' ' -f3)"
143 ## check if libvirt_version is installed
144 virsh -v | grep -e $libvirt_version || { echo "$libvirt_version needs to be installed!!!" ; exit 1 ; }
145 # host_fcdistro="$(cat /etc/fedora-release | cut -d' ' -f3)"
146 # if [ ! -f /etc/yum.repos.d/libvirt.repo ] ; then
147 # touch /etc/yum.repos.d/libvirt.repo
148 # cat <<EOF > /etc/yum.repos.d/libvirt.repo
150 #name=libvirt-1.0.2-1
151 #baseurl=http://build.onelab.eu/lxc/2013.02.25--lxc$host_fcdistro/RPMS/
156 # yum --assumeno update
157 # check_yumgroup_installed "Development Tools"
158 # check_yum_installed libcap-devel
159 # check_yum_installed libvirt
160 # systemctl start libvirtd
163 #################### bride initialization
164 check_yum_installed bridge-utils
166 isInstalled=$(netstat -rn | grep '^0.0.0.0' | awk '{print $8;}')
167 if [ "$isInstalled" != "br0" ] ; then
177 function configure_fedora() {
179 # disable selinux in fedora
180 mkdir -p $rootfs_path/selinux
181 echo 0 > $rootfs_path/selinux/enforce
183 # configure the network
185 cat <<EOF > ${rootfs_path}/etc/sysconfig/network-scripts/ifcfg-$IFNAME
199 if [[ "$fcdistro" == "f18" ]] ; then
200 cat <<EOF > ${rootfs_path}/etc/hostname
204 cat <<EOF > ${rootfs_path}/etc/sysconfig/network
209 cat <<EOF > $rootfs_path/etc/hosts
210 127.0.0.1 localhost $HOSTNAME
214 dev_path="${rootfs_path}/dev"
217 mknod -m 666 ${dev_path}/null c 1 3
218 mknod -m 666 ${dev_path}/zero c 1 5
219 mknod -m 666 ${dev_path}/random c 1 8
220 mknod -m 666 ${dev_path}/urandom c 1 9
221 mkdir -m 755 ${dev_path}/pts
222 mkdir -m 1777 ${dev_path}/shm
223 mknod -m 666 ${dev_path}/tty c 5 0
224 mknod -m 666 ${dev_path}/tty0 c 4 0
225 mknod -m 666 ${dev_path}/tty1 c 4 1
226 mknod -m 666 ${dev_path}/tty2 c 4 2
227 mknod -m 666 ${dev_path}/tty3 c 4 3
228 mknod -m 666 ${dev_path}/tty4 c 4 4
229 mknod -m 600 ${dev_path}/console c 5 1
230 mknod -m 666 ${dev_path}/full c 1 7
231 mknod -m 600 ${dev_path}/initctl p
232 mknod -m 666 ${dev_path}/ptmx c 5 2
234 #echo "setting root passwd to $root_password"
235 #echo "root:$root_password" | chroot $rootfs_path chpasswd
241 function configure_fedora_init() {
243 sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.sysinit
244 sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.d/rc.sysinit
245 # don't mount devpts, for pete's sake
246 sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.sysinit
247 sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.d/rc.sysinit
248 chroot ${rootfs_path} /sbin/chkconfig udev-post off
249 chroot ${rootfs_path} /sbin/chkconfig network on
252 # this code of course is for guests that do run on systemd
253 function configure_fedora_systemd() {
254 # so ignore if we can't find /etc/systemd at all
255 [ -d ${rootfs_path}/etc/systemd ] || return 0
256 # otherwise let's proceed
257 unlink ${rootfs_path}/etc/systemd/system/default.target
258 ln -s /lib/systemd/system/multi-user.target ${rootfs_path}/etc/systemd/system/default.target
259 touch ${rootfs_path}/etc/fstab
260 ln -s /dev/null ${rootfs_path}/etc/systemd/system/udev.service
262 # this was intended for f16 initially, in order to enable getty that otherwise would not start
263 # having a getty running is helpful only if ssh won't start though, and we see a correlation between
264 # VM's that refuse to lxc-stop and VM's that run crazy getty's
265 # so, turning getty off for now instead
266 # #dependency on a device unit fails it specially that we disabled udev
267 # sed -i 's/After=dev-%i.device/After=/' ${rootfs_path}/lib/systemd/system/getty\@.service
268 ln -s /dev/null ${rootfs_path}/etc/systemd/system/"getty@.service"
269 rm -f ${rootfs_path}/etc/systemd/system/getty.target.wants/*service || :
270 # can't seem to handle this one with systemctl
271 chroot ${rootfs_path} /sbin/chkconfig network on
274 function download_fedora() {
276 # check the mini fedora was not already downloaded
277 INSTALL_ROOT=$cache/partial
280 # download a mini fedora into a cache
281 echo "Downloading fedora minimal ..."
283 mkdir -p $INSTALL_ROOT
284 if [ $? -ne 0 ]; then
285 echo "Failed to create '$INSTALL_ROOT' directory"
289 mkdir -p $INSTALL_ROOT/etc/yum.repos.d
290 mkdir -p $INSTALL_ROOT/dev
291 mknod -m 0444 $INSTALL_ROOT/dev/random c 1 8
292 mknod -m 0444 $INSTALL_ROOT/dev/urandom c 1 9
294 # copy yum config and repo files
295 cp /etc/yum.conf $INSTALL_ROOT/etc/
296 cp /etc/yum.repos.d/fedora* $INSTALL_ROOT/etc/yum.repos.d/
298 # append fedora repo files with desired $release and $basearch
299 for f in $INSTALL_ROOT/etc/yum.repos.d/*
301 sed -i "s/\$basearch/$arch/g; s/\$releasever/$release/g;" $f
304 MIRROR_URL=http://mirror.onelab.eu/fedora/releases/$release/Everything/$arch/os
305 RELEASE_URL1="$MIRROR_URL/Packages/fedora-release-$release-1.noarch.rpm"
306 # with fedora18 the rpms are scattered by first name
307 RELEASE_URL2="$MIRROR_URL/Packages/f/fedora-release-$release-1.noarch.rpm"
308 RELEASE_TARGET=$INSTALL_ROOT/fedora-release-$release.noarch.rpm
310 for attempt in $RELEASE_URL1 $RELEASE_URL2; do
311 if curl -f $attempt -o $RELEASE_TARGET ; then
312 echo "Retrieved $attempt"
316 echo "Failed attempt $attempt"
319 [ -n "$found" ] || { echo "Could not retrieve fedora-release rpm - exiting" ; exit 1; }
321 mkdir -p $INSTALL_ROOT/var/lib/rpm
322 rpm --root $INSTALL_ROOT --initdb
323 # when installing f12 this apparently is already present, so ignore result
324 rpm --root $INSTALL_ROOT -ivh $INSTALL_ROOT/fedora-release-$release.noarch.rpm || :
325 # however f12 root images won't get created on a f18 host
326 # (the issue here is the same as the one we ran into when dealing with a vs-box)
327 # in a nutshell, in f12 the glibc-common and filesystem rpms have an apparent conflict
328 # >>> file /usr/lib/locale from install of glibc-common-2.11.2-3.x86_64 conflicts
329 # with file from package filesystem-2.4.30-2.fc12.x86_64
330 # in fact this was - of course - allowed by f12's rpm but later on a fix was made
331 # http://rpm.org/gitweb?p=rpm.git;a=commitdiff;h=cf1095648194104a81a58abead05974a5bfa3b9a
332 # So ideally if we want to be able to build f12 images from f18 we need an rpm that has
333 # this patch undone, like we have in place on our f14 boxes (our f14 boxes need a f18-like rpm)
335 YUM="yum --installroot=$INSTALL_ROOT --nogpgcheck -y"
336 PKG_LIST="yum initscripts passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
337 echo "$YUM install $PKG_LIST"
338 $YUM install $PKG_LIST
340 if [ $? -ne 0 ]; then
341 echo "Failed to download the rootfs, aborting."
345 mv "$INSTALL_ROOT" "$cache/rootfs"
346 echo "Download complete."
352 function copy_fedora() {
354 # make a local copy of the minifedora
355 echo -n "Copying rootfs to $rootfs_path ..."
356 mkdir -p $rootfs_path
357 rsync -a $cache/rootfs/ $rootfs_path/
362 function update_fedora() {
364 YUM="yum --installroot $cache/rootfs -y --nogpgcheck"
369 function install_fedora() {
372 mkdir -p /var/lock/subsys/
375 if [ $? -ne 0 ]; then
376 echo "Cache repository is busy."
380 echo "Checking cache download in $cache/rootfs ... "
381 if [ ! -e "$cache/rootfs" ]; then
383 if [ $? -ne 0 ]; then
384 echo "Failed to download 'fedora base'"
388 echo "Cache found. Updating..."
390 if [ $? -ne 0 ]; then
391 echo "Failed to update 'fedora base', continuing with last known good cache"
393 echo "Update finished"
397 echo "Copy $cache/rootfs to $rootfs_path ... "
399 if [ $? -ne 0 ]; then
400 echo "Failed to copy rootfs"
406 ) 200>/var/lock/subsys/lxc
412 function copy_configuration() {
414 mkdir -p $config_path
415 cat <<EOF >> $config_path/config
420 lxc.rootfs = $rootfs_path
421 lxc.mount = $config_path/fstab
423 lxc.network.type = $lxc_network_type
424 lxc.network.flags = up
425 lxc.network.link = $lxc_network_link
426 lxc.network.name = $IFNAME
427 lxc.network.mtu = 1500
428 lxc.network.ipv4 = $IP/$CIDR
429 lxc.network.veth.pair = $veth_pair
431 #lxc.cgroup.devices.deny = a
433 lxc.cgroup.devices.allow = c 1:3 rwm
434 lxc.cgroup.devices.allow = c 1:5 rwm
436 lxc.cgroup.devices.allow = c 5:1 rwm
437 lxc.cgroup.devices.allow = c 5:0 rwm
438 lxc.cgroup.devices.allow = c 4:0 rwm
439 lxc.cgroup.devices.allow = c 4:1 rwm
441 lxc.cgroup.devices.allow = c 1:9 rwm
442 lxc.cgroup.devices.allow = c 1:8 rwm
443 lxc.cgroup.devices.allow = c 136:* rwm
444 lxc.cgroup.devices.allow = c 5:2 rwm
446 lxc.cgroup.devices.allow = c 254:0 rwm
447 lxc.cgroup.devices.allow = b 255:0 rwm
452 cat <<EOF > $config_path/fstab
453 proc $rootfs_path/proc proc nodev,noexec,nosuid 0 0
454 devpts $rootfs_path/dev/pts devpts defaults 0 0
455 sysfs $rootfs_path/sys sysfs defaults 0 0
457 if [ $? -ne 0 ]; then
458 echo "Failed to add configuration"
468 # overwrite lxc's internal yum config
469 function configure_yum_in_lxc () {
478 echo "Initializing yum.repos.d in $lxc"
479 rm -f $rootfs_path/etc/yum.repos.d/*
481 cat > $rootfs_path/etc/yum.repos.d/building.repo <<EOF
483 name=Fedora $release - $arch
484 baseurl=http://mirror.onelab.eu/fedora/releases/$release/Everything/$arch/os/
488 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
491 name=Fedora $release - $arch - Updates
492 baseurl=http://mirror.onelab.eu/fedora/updates/$release/$arch/
496 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
499 # for using vtest-init-lxc.sh as a general-purpose lxc creation wrapper
500 # just mention 'none' as the repo url
501 if [ -n "$MYPLC_MODE" -a "$REPO_URL" != "none" ] ; then
502 if [ ! -d $rootfs_path/etc/yum.repos.d ] ; then
503 echo "WARNING : cannot create myplc repo"
505 # exclude kernel from fedora repos
506 yumexclude=$(pl_plcyumexclude $fcdistro $pldistro $DIRNAME)
507 for repo in $rootfs_path/etc/yum.repos.d/* ; do
508 [ -f $repo ] && yumconf_exclude $repo "exclude=$yumexclude"
510 # the build repo is not signed at this stage
511 cat > $rootfs_path/etc/yum.repos.d/myplc.repo <<EOF
522 # return yum or debootstrap
523 function package_method () {
526 f[0-9]*|centos[0-9]*|sl[0-9]*) echo yum ;;
527 lenny|etch) echo debootstrap ;;
528 *) echo Unknown distro $fcdistro ;;
532 # return arch from debian distro and personality
533 function canonical_arch () {
534 personality=$1; shift
536 case $(package_method $fcdistro) in
538 case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
540 case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
542 echo Unknown-arch-3 ;;
546 # the new test framework creates /timestamp in /vservers/<name> *before* populating it
547 function almost_empty () {
549 # non existing is fine
550 [ ! -d $dir ] && return 0;
551 # need to have at most one file
552 count=$(cd $dir; ls | wc -l); [ $count -le 1 ];
555 function setup_lxc() {
559 #trap failure ERR INT
564 personality=$1; shift
566 # create lxc container
568 if [ $? -ne 0 ]; then
569 echo "failed write configuration file"
574 if [ $? -ne 0 ]; then
575 echo "failed to install fedora"
580 if [ $? -ne 0 ]; then
581 echo "failed to configure fedora for a container"
585 if [ "$(echo $fcdistro | cut -d"f" -f2)" -le "14" ]; then
586 configure_fedora_init
588 configure_fedora_systemd
592 mkdir $rootfs_path/cgroup
595 cp /etc/resolv.conf $rootfs_path/etc/resolv.conf
596 # and /etc/hosts for at least localhost
597 [ -f $rootfs_path/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > $rootfs_path/etc/hosts
600 mkdir $rootfs_path/root/.ssh
601 cat /root/.ssh/id_rsa.pub >> $rootfs_path/root/.ssh/authorized_keys
603 # copy libvirt xml template
604 veth_pair="i$(echo $HOSTNAME | cut -d. -f1)"
606 cat > $config_path/$tmpl_name<<EOF
609 <memory>524288</memory>
611 <type arch='$arch2'>exe</type>
612 <init>/sbin/init</init>
618 <clock offset='utc'/>
619 <on_poweroff>destroy</on_poweroff>
620 <on_reboot>restart</on_reboot>
621 <on_crash>destroy</on_crash>
623 <emulator>/usr/libexec/libvirt_lxc</emulator>
624 <filesystem type='mount'>
625 <source dir='$rootfs_path'/>
628 <interface type="bridge">
629 <source bridge="br0"/>
630 <target dev='$veth_pair'/>
632 <console type='pty' />
635 <name>host-bridge</name>
636 <forward mode="bridge"/>
642 # define lxc container for libvirt
643 virsh -c lxc:// define $config_path/$tmpl_name
646 chroot $rootfs_path /bin/rpm --rebuilddb
648 configure_yum_in_lxc $lxc $fcdistro $pldistro
653 function devel_or_vtest_tools () {
662 personality=$1; shift
664 pkg_method=$(package_method $fcdistro)
666 # check for .pkgs file based on pldistro
667 if [ -n "$VBUILD_MODE" ] ; then
672 pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $pkgsname)
674 ### install individual packages, then groups
675 # get target arch - use uname -i here (we want either x86_64 or i386)
677 lxc_arch=$(chroot $rootfs_path /bin/uname -i)
678 # on debian systems we get arch through the 'arch' command
679 [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot $rootfs_path /bin/arch)
681 packages=$(pl_getPackages -a $lxc_arch $fcdistro $pldistro $pkgsfile)
682 groups=$(pl_getGroups -a $lxc_arch $fcdistro $pldistro $pkgsfile)
684 case "$pkg_method" in
686 [ -n "$packages" ] && chroot $rootfs_path /usr/bin/yum -y install $packages
687 for group_plus in $groups; do
688 group=$(echo $group_plus | sed -e "s,+++, ,g")
689 chroot $rootfs_path /usr/bin/yum -y groupinstall "$group"
691 # store current rpm list in /init-lxc.rpms in case we need to check the contents
692 chroot $rootfs_path /bin/rpm -aq > $rootfs_path/init-lxc.rpms
695 chroot $rootfs_path /usr/bin/apt-get update
696 for package in $packages ; do
697 chroot $rootfs_path /usr/bin/apt-get install -y $package
699 ### xxx todo install groups with apt..
702 echo "unknown pkg_method $pkg_method"
709 function post_install () {
710 if [ -n "$VBUILD_MODE" ] ; then
711 post_install_vbuild "$@"
713 post_install_myplc "$@"
715 # setup localtime from the host
717 cp /etc/localtime $rootfs_path/etc/localtime
720 function post_install_vbuild () {
727 personality=$1; shift
729 ### From myplc-devel-native.spec
730 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
731 cat << EOF | chroot $rootfs_path /bin/bash -x
732 # set up /dev/loop* in lxc
733 for i in \$(seq 0 255) ; do
734 /bin/mknod -m 640 /dev/loop\$i b 7 \$i
737 # create symlink for /dev/fd
738 [ ! -e "/dev/fd" ] && /bin/ln -s /proc/self/fd /dev/fd
740 # modify /etc/rpm/macros to not use /sbin/new-kernel-pkg
741 /bin/sed -i 's,/sbin/new-kernel-pkg:,,' /etc/rpm/macros
742 if [ -h "/sbin/new-kernel-pkg" ] ; then
743 filename=\$(/bin/readlink -f /sbin/new-kernel-pkg)
744 if [ "\$filename" == "/sbin/true" ] ; then
745 /bin/echo "WARNING: /sbin/new-kernel-pkg symlinked to /sbin/true"
746 /bin/echo "\tmost likely /etc/rpm/macros has /sbin/new-kernel-pkg declared in _netsharedpath."
747 /bin/echo "\tPlease remove /sbin/new-kernel-pkg from _netsharedpath and reintall mkinitrd."
752 # customize root's prompt
753 /bin/cat << PROFILE > /root/.profile
754 export PS1="[$lxc] \\w # "
760 # add a "build" user to the system
761 builduser=\$(grep "^build:" /etc/passwd | wc -l)
762 if [ \$builduser -eq 0 ] ; then
763 groupadd -o -g \$gid build;
764 useradd -o -c 'Automated Build' -u \$uid -g \$gid -n -M -s /bin/bash build;
767 # Allow build user to build certain RPMs as root
768 if [ -f /etc/sudoers ] ; then
769 buildsudo=\$(grep "^build.*ALL=(ALL).*NOPASSWD:.*ALL" /etc/sudoers | wc -l)
770 if [ \$buildsudo -eq 0 ] ; then
771 echo "build ALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers
773 sed -i 's,^Defaults.*requiretty,#Defaults requiretty,' /etc/sudoers
780 function post_install_myplc () {
786 personality=$1; shift
788 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
789 cat << EOF | chroot $rootfs_path /bin/bash -x
791 # create /etc/sysconfig/network if missing
792 [ -f /etc/sysconfig/network ] || /bin/echo NETWORKING=yes > /etc/sysconfig/network
794 # create symlink for /dev/fd
795 [ ! -e "/dev/fd" ] && /bin/ln -s /proc/self/fd /dev/fd
797 # turn off regular crond, as plc invokes plc_crond
798 /sbin/chkconfig crond off
800 # take care of loginuid in /etc/pam.d
801 /bin/sed -i "s,#*\(.*loginuid.*\),#\1," /etc/pam.d/*
803 # customize root's prompt
804 /bin/cat << PROFILE > /root/.profile
805 export PS1="[$lxc] \\w # "
811 function start_lxc() {
815 #trap failure ERR INT
819 virsh -c lxc:// start $lxc
821 echo $IP is up, waiting for ssh...
823 #wait max 5 min for sshd to start
825 stop_time=$(($(date +%s) + 300))
826 current_time=$(date +%s)
829 while [ "$current_time" -lt "$stop_time" ] ; do
830 echo "$counter-th attempt to reach sshd in container $lxc ..."
831 ssh -o "StrictHostKeyChecking no" $IP 'uname -i' && { ssh_up=true; echo "SSHD in container $lxc is UP"; break ; } || :
833 current_time=$(($current_time + 10))
834 counter=$(($counter+1))
837 # Thierry: this is fatal, let's just exit with a failure here
838 [ -z $ssh_up ] && { echo "SSHD in container $lxc is not running" ; exit 1 ; }
845 echo "Usage: $COMMAND_VBUILD [options] lxc-name"
846 echo "Usage: $COMMAND_MYPLC [options] lxc-name repo-url [ -- lxc-options ]"
848 echo " This command creates a fresh lxc instance, for building, or running, myplc"
849 echo "Supported options"
850 echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
851 echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
852 echo " -p personality - defaults to $DEFAULT_PERSONALITY"
853 echo " -i ifname: determines ip and netmask attached to ifname, and passes it to the lxc"
854 echo "-- lxc-options"
855 echo " --netdev : interface to be defined inside lxc"
856 echo " --interface : IP to be defined for the lxc"
857 echo " --hostname : Hostname to be defined for the lxc"
858 echo "With $COMMAND_MYPLC you can give 'none' as the URL, in which case"
859 echo " myplc.repo does not get created"
867 #trap failure ERR INT
882 while getopts "f:d:p:i:" opt ; do
884 f) fcdistro=$OPTARG;;
885 d) pldistro=$OPTARG;;
886 p) personality=$OPTARG;;
892 shift $(($OPTIND - 1))
894 # parse fixed arguments
895 [[ -z "$@" ]] && usage
897 if [ -n "$MYPLC_MODE" ] ; then
898 [[ -z "$@" ]] && usage
902 # parse vserver options
903 if [[ -n "$@" ]] ; then
904 if [ "$1" == "--" ] ; then
912 eval set -- "$LXC_OPTIONS"
917 --netdev) IFNAME=$2; shift 2;;
918 --interface) IP=$2; shift 2;;
919 --hostname) HOSTNAME=$2; shift 2;;
925 if [ -n "$VBUILD_MODE" ] ; then
926 [ -z "$IFNAME" ] && IFNAME=$DEFAULT_IFNAME
927 [ -z "$HOSTNAME" ] && HOSTNAME=$lxc
930 [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
931 [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
932 [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
934 release=$(echo $fcdistro | cut -df -f2)
936 if [ "$personality" == "linux32" ]; then
939 elif [ "$personality" == "linux64" ]; then
943 echo "Unknown personality: $personality"
946 # need lxc installed before we can run lxc-ls
947 # need bridge installed
950 if [ -n "$VBUILD_MODE" ] ; then
952 # Bridge IP affectation
953 x=$(echo $personality | cut -dx -f2)
954 y=$(echo $fcdistro | cut -df -f2)
958 NETMASK="255.255.255.0"
959 GATEWAY="192.168.122.1"
961 lxc_network_type=veth
962 lxc_network_link=virbr0
964 echo "the IP address of container $lxc is $IP "
966 [[ -z "$REPO_URL" ]] && usage
967 [[ -z "$IP" ]] && usage
969 NETMASK=$(ifconfig br0 | grep 'inet ' | awk '{print $4}' | sed -e 's/.*://')
970 GATEWAY=$(route -n | grep 'UG' | awk '{print $2}')
971 [[ -z "$HOSTNAME" ]] && usage
972 lxc_network_type=veth
974 veth_pair="i$(echo $HOSTNAME | cut -d. -f1)"
977 CIDR=$(cidr_notation $NETMASK)
980 if [ "$(id -u)" != "0" ]; then
981 echo "This script should be run as 'root'"
986 [ ! -d $path ] && mkdir $path
987 rootfs_path=$path/$lxc/rootfs
988 config_path=$path/$lxc
989 cache_base=/var/cache/lxc/fedora/$arch
990 cache=$cache_base/$release
993 # check whether the rootfs directory is created to know if the container exists
994 # bacause /var/lib/lxc/$lxc is already created while putting $lxc.timestamp
995 [ -d $rootfs_path ] && { echo "container $lxc already exists - exiting" ; exit 1 ; }
997 setup_lxc $lxc $fcdistro $pldistro $personality
999 devel_or_vtest_tools $lxc $fcdistro $pldistro $personality
1001 post_install $lxc $personality